org.encog.neural.neat.training.opp

## Class NEATMutateWeights

- java.lang.Object
- - org.encog.neural.neat.training.opp.NEATMutation
  - - org.encog.neural.neat.training.opp.NEATMutateWeights

- All Implemented Interfaces:
    EvolutionaryOperator

      public class NEATMutateWeights
      extends NEATMutation

  Mutate the weights of a genome. A method is select the links for mutation. Another method should also be provided for the actual mutation. ----------------------------------------------------------------------------- http://www.cs.ucf.edu/~kstanley/ Encog's NEAT implementation was drawn from the following three Journal Articles. For more complete BibTeX sources, see NEATNetwork.java. Evolving Neural Networks Through Augmenting Topologies Generating Large-Scale Neural Networks Through Discovering Geometric Regularities Automatic feature selection in neuroevolution

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `NEATMutateWeights(SelectLinks theLinkSelection, MutateLinkWeight theWeightMutation)` Construct a weight mutation operator.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `SelectLinks` | `getLinkSelection()`
    `MutateLinkWeight` | `getWeightMutation()`
    `void` | `performOperation(Random rnd, Genome[] parents, int parentIndex, Genome[] offspring, int offspringIndex)` Perform the evolutionary operation.
    `String` | `toString()`

    - ### Methods inherited from class org.encog.neural.neat.training.opp.NEATMutation

      `chooseRandomNeuron, createLink, getElementPos, getOwner, init, isDuplicateLink, isNeuronNeeded, obtainGenome, offspringProduced, parentsNeeded, removeNeuron`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### NEATMutateWeights

          public NEATMutateWeights(SelectLinks theLinkSelection,
                           MutateLinkWeight theWeightMutation)

      Construct a weight mutation operator.
      Parameters:
        `theLinkSelection` - The method used to choose the links for mutation.
        `theWeightMutation` - The method used to actually mutate the weights.

  - ### Method Detail

    - #### getLinkSelection

          public SelectLinks getLinkSelection()

      Returns:
        The method used to select links for mutation.

    - #### getWeightMutation

          public MutateLinkWeight getWeightMutation()

      Returns:
        The method used to mutate the weights.

    - #### performOperation

          public void performOperation(Random rnd,
                              Genome[] parents,
                              int parentIndex,
                              Genome[] offspring,
                              int offspringIndex)

      Perform the evolutionary operation.
      Parameters:
        `rnd` - A random number generator.
        `parents` - The parents.
        `parentIndex` - The index into the parents array.
        `offspring` - The offspring.
        `offspringIndex` - An index into the offspring array.

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

Copyright © 2014. All Rights Reserved.